-- Wild Growth Watcher
-- Sends a log to the chat window about the time remaining on Wild Growth
-- Note: This only works if Wild Growth is applied to the player's target by request

-- Deselecting your target will stop the log from appending to the chat window

local isEnabled = true
local buffID = nil
local unitID = nil
local timeRemaining = nil
local targetName = nil

local function Update()
	if buffID then
		local detail = Inspect.Buff.Detail(unitID, buffID)
		if detail then		
			buffTimeRemaining = detail.remaining
		end
		if not timeRemaining then timeRemaining = math.floor(buffTimeRemaining) end
		if timeRemaining > buffTimeRemaining then
			timeRemaining = math.floor(buffTimeRemaining)
			if timeRemaining == 0 then
				print("Wild Growth expired from " .. targetName)
				buffID = nil
				unitID = nil
				timeRemaining = nil
			else
				print("Wild Growth expiring in " .. timeRemaining .. " seconds")
			end
		end
	end
end

local function StartGrowthWatcher(u,t)
	if Inspect.Unit.Lookup(u) == "player.target" then
		local buffs = Inspect.Buff.List(u)
		if not buffs then return end		
		local buff_details = Inspect.Buff.Detail(u, buffs)
		for id,buff in pairs(buff_details) do
			local thisbuff = Inspect.Buff.Detail(u, id)
			if thisbuff.name == "Wild Growth" and not buffID then
				buffID = id
				unitID = u
				targetName = Inspect.Unit.Detail(u).name
				print(thisbuff.name .. " Cast on " .. targetName)
			end
		end
	end
end

local function toggleGrowthWatcher()
	if isEnabled then
		table.remove(Event.Buff.Add)
		print("Growth Watcher Disabled")
		isEnabled = false
	else
		table.insert(Event.Buff.Add, {StartGrowthWatcher, "WildGrowthWatcher", "init"})
		isEnabled = true
		print("Growth Watcher Enabled")
	end
end

table.insert(Event.Buff.Add, {StartGrowthWatcher, "WildGrowthWatcher", "init"})
table.insert(Command.Slash.Register("growthWatcher"), {toggleGrowthWatcher, "WildGrowthWatcher", "toggleGrowthWatcher"})
table.insert(Event.System.Update.Begin, {Update, "WildGrowthWatcher", "growthTick"})